# Stuff to be implemented externally :
Source10: kmodtool
%define   kmodtool sh %{SOURCE10}
# End stuff to be ...

# hardcode for now:
%{!?kversion: %define kversion 2.6.30-7}

%define kmod_name nvidia
%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)
%define kvariants PAE ""
%define upvar ""
%{!?kvariants: %define kvariants %{?upvar}}


Distribution:	CCux
Packager:  	Christian Metzen <metzench@ccux-linux.de>

Summary: 	Nvidia Display Driver kernel-module
Name: 		%{kmod_name}-kmod
Version: 	1.0.190.18
Release: 	1.%(echo %{kverrel} | tr - _)
Group: 		System/Kernel
License: 	Distributable
URL:        	http://www.nvidia.com/

#Source is created from these files:
# ftp://download.nvidia.com/XFree86/Linux-x86/1.0-8756/NVIDIA-Linux-x86-1.0-8762-pkg0.run
# ftp://download.nvidia.com/XFree86/Linux-x86_64/1.0-8756/NVIDIA-Linux-x86_64-1.0-8762-pkg2.run
Source0:	nvidia-glx-kmod-data-%{version}.tar.bz2	
# Helper script to create SOURCE0 tarball from binary installer
Source200:	prep_nvidia.sh
Patch0:		nvidia-kmod-linux2630.patch
ExclusiveArch:  i686
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

# Require for rpm lzma compression transition
Requires:        rpm >= 4.4.2.3-1

Obsoletes:	kernel-module-nvidia

%description
This package provides Nvidia hardware accelerated OpenGL support
for Nvidia chipsets from Geforce2, Quadro4 or newer.


# magic hidden here:
%{expand:%(%{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}

%prep
# To understand the magic better or to debug it, uncomment this :
#%{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null
#sleep 5
%setup -q -c -T -a 0
# add global patches here :
#%patch0 -p1

%ifarch %{ix86}
pushd nvidiapkg-x86/
# add arch specific patches here :
#%patch0 -p2
popd
%else
pushd nvidiapkg-x64/
#%patch0 -p1
popd
%endif

for kvariant in %{kvariants} ; do
%ifarch %{ix86}
    cp -a nvidiapkg-x86 _kmod_build_$kvariant
%else
    cp -a nvidiapkg-x64 _kmod_build_$kvariant
%endif
done


%build
for kvariant in %{kvariants}
do
    ksrc=%{_usrsrc}/kernels/%{kverrel}.%{_target_cpu}${kvariant:+.$kvariant}
    pushd _kmod_build_$kvariant/usr/src/nv/
    ln -s -f Makefile.kbuild Makefile
    make SYSSRC="${ksrc}" module
    popd
done


%install
rm -rf $RPM_BUILD_ROOT
for kvariant in %{kvariants}
do
    install -D -m 0644 _kmod_build_$kvariant/usr/src/nv/nvidia.ko $RPM_BUILD_ROOT/lib/modules/%{kverrel}.%{_target_cpu}${kvariant:+.$kvariant}/extra/%{kmod_name}/nvidia.ko
done
chmod u+x $RPM_BUILD_ROOT/lib/modules/*/extra/%{kmod_name}/*

%clean
%{__rm} -rf %{buildroot}

%changelog
* Wed Jul 27 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.0.190.18-1
- version update
- kernel 2.6.30-7
* Tue Jul 21 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.0.185.19-5
- kernel 2.6.30-6
* Wed Jun 10 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.0.185.19-4
- kernel 2.6.30
* Wed May 20 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.0.185.19-3
- kernel 2.6.29-9
* Wed May 13 2009 Christian Metzen <metzench@ccux-linux.de> 1.0.185.19-2
- kernel 2.6.29-8
* Tue Apr 07 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.0.185.19-1
- version update
* Fri Apr 03 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.0.185.13-2
- kernel 2.6.29-6
* Fri Mar 20 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.0.185.13-1
- version update
- kernel 2.6.29-4
* Fri Mar 13 2009 Christian Wasem <wasem@ccux-linux.de> 1.0.180.27-2
- version update
* Fri Jan 30 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.0.180.27-1
- version update
* Mon Jan 26 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.0.180.22-4
- kernel 2.6.28-4
* Mon Jan 19 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.0.180.22-3
- kernel 2.6.28-3
* Fri Jan 16 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.0.180.22-2
- kernel 2.6.28-2
* Sat Jan 10 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.0.180.22-1
- version update
* Thu Dec 25 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.180.18-2
- kernel 2.6.28-1
* Tue Dec 23 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.180.18-1
- version update, beta
- kernel 2.6.27-18
* Thu Dec 18 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.180.16-3
- kernel 2.6.27-18
* Sun Dec 14 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.180.16-2
- kernel 2.6.27-17
* Sun Dec 14 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.180.16-1
- version update, beta
- kernel 2.6.27-16
* Thu Dec 11 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.180.11-2
- rebuilt with proper linking (FS#50)
* Wed Dec 10 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.180.11-1
- version update, beta
- kernel 2.6.27-16
* Sat Nov 22 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.180.08-2
- kernel 2.6.27-15
* Thu Nov 20 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.180.08-1
- version update, beta
- kernel 2.6.27-14
* Sat Nov 15 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.180.06-1
- version update, beta
- kernel 2.6.27-14
* Sat Nov 15 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.82-2
- kernel 2.6.27-14
* Thu Nov 13 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.82-1
- version update
- kernel 2.6.27-13
* Sat Nov 08 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.80-9
- kernel 2.6.27-13
* Mon Nov 03 2008 Christian Metzen <metzench@ccux-linux.de> 1.0.177.80-8
- kernel 2.6.27-12
* Sun Oct 26 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.80-7
- kernel 2.6.27-11
* Sun Oct 26 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.80-6
- kernel 2.6.27-10
* Thu Oct 23 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.80-5
- kernel 2.6.27-9
* Mon Oct 20 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.80-4
- kernel 2.6.27-8
* Sat Oct 18 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.80-3
- kernel 2.6.27-7
* Fri Oct 10 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.80-2
- kernel 2.6.27-6
* Tue Oct 07 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.80-1
- version update
- kernel 2.6.27-5
* Fri Oct 03 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.78-3
- kernel 2.6.27-4
* Tue Sep 30 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.78-2
- kernel 2.6.27-3
* Sat Sep 27 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.78-1
- version update
* Mon Sep 22 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.76-2
- kernel 2.6.27-2
* Sat Sep 20 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.76-1
- version update
* Wed Sep 17 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.70-4
- kernel 2.6.27-1
* Tue Sep 09 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.70-3
- kernel 2.6.26-10
* Sat Aug 30 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.70-2
- kernel 2.6.26-9
* Thu Aug 28 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.70-1
- version update
* Fri Aug 22 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.68-1
- version update
* Thu Aug 21 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.67-1
- version update
- kernel 2.6.26-8
* Thu Aug 07 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.13-14
- kernel 2.6.26-7
* Wed Aug 06 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.13-13
- kernel 2.6.26-6
* Sun Jul 27 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.13-12
- fixed kernel dependencies
* Fri Jul 25 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.13-11
- kernel 2.6.26-5
* Wed Jul 23 2008 Christian Metzen <metzench@ccux-linux.de> 1.0.177.13-10
- Kernel 2.6.26-4
* Sun Jul 20 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.13-9
- kernel 2.6.26-3
* Sat Jul 19 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.13-8
- kernel 2.6.26-2
* Fri Jul 04 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.13-7
- kernel 2.6.26-1
* Fri Jul 04 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.13-6
- kernel 2.6.25-15
* Mon Jun 30 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.13-5
- kernel 2.6.25-14
* Mon Jun 30 2008 Christian Metzen <metzench@ccux-linux.de> 1.0.177.13-4
- Kernel 2.6.25-13
* Wed Jun 25 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.13-3
- kernel 2.6.25-12
* Sun Jun 22 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.13-2
- kernel 2.6.25-11
* Sat Jun 21 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.177.13-1
- version update 
- kernel 2.6.25-10
* Mon Jun 16 2008 Christian Metzen <metzench@ccux-linux.de> 1.0.173.14.05-3
- Kernel 2.6.25-9
* Sun Jun 08 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.173.14.05-2
- kernel 2.6.25-8
* Fri May 30 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.173.14.05-1
- version update
* Tue May 27 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.173.08-1
- version update
* Fri May 16 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.169.12-7
- kernel 2.6.25-7
* Sat May 10 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.169.12-6
- kernel 2.6.25-6
* Wed May 07 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.169.12-5
- kernel 2.6.25-5
* Fri May 02 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.169.12-4
- kernel 2.6.25-4
* Thu Apr 17 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.169.12-3
- kernel 2.6.25-3
* Thu Mar 27 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.169.12-2
- kernel 2.6.24-11
* Sat Mar 15 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.169.12-1
- version update
- kernel 2.6.24-10
* Fri Jan 25 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.169.09-2
- kernel 2.6.24-9
* Tue Jan 22 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.169.09-1
- version update
* Thu Jan 17 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.169.07-5
- kernel 2.6.24-8
* Mon Jan 07 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.169.07-4
- kernel 2.6.24-7
* Sun Dec 30 2007 Christian Metzen <metzench@ccux-linux.de> 1.0.169.07-3
- kernel 2.6.24-6, modified kmodtool for correct Package group
* Fri Dec 21 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.169.07-2
- kernel 2.6.24-5
* Fri Dec 21 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.169.07-1
- version update
* Thu Dec 13 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.169.04-5
- kernel 2.6.24-4
* Sat Dec 08 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.169.04-4
- kernel 2.6.24-3
* Tue Dec 04 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.169.04-3
- kernel 2.6.24-2
* Sat Nov 24 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.169.04-2
- kernel 2.6.24-1
* Sat Nov 17 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.169.04-1
- Version update
* Sat Oct 27 2007 Christian Metzen <metzench@ccux-linux.de> 1.0.100.14.23-3
- kernel 2.6.23-7
* Thu Oct 25 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.100.14.23-2
- kernel 2.6.23-6
* Mon Oct 22 2007 Christian Metzen <metzench@ccux-linux.de> 1.0.100.14.23-1
- Version update
* Sat Oct 13 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.100.14.19-9
- kernel 2.6.23-5
* Thu Oct 11 2007 Christian Metzen <metzench@ccux-linux.de> 1.0.100.14.19-8
- Kernel 2.6.23-4
* Thu Oct 11 2007 Christian Metzen <metzench@ccux-linux.de> 1.0.100.14.19-7
- Kernel 2.6.23-3
* Thu Oct 11 2007 Christian Metzen <metzench@ccux-linux.de> 1.0.100.14.19-6
- Kernel 2.6.23-2
* Wed Oct 10 2007 Christian Metzen <metzench@ccux-linux.de> 1.0.100.14.19-5
- Kernel 2.6.23-1
* Tue Oct 09 2007 Christian Metzen <metzench@ccux-linux.de> 1.0.100.14.19-4
- Kernel 2.6.22-10
* Sat Sep 29 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.100.14.19-3
- kernel 2.6.22-9
* Wed Sep 19 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.100.14.19-2
- kernel 2.6.22-7
* Wed Sep 19 2007 Christian Metzen <metzench@ccux-linux.de> 1.0.100.14.19-1
- Version update
* Mon Jun 25 2007 Stefan Gottwald <gotti@ccux-linux.de> 1.0.100.14.11-1
- Version Update
* Thu Jun 14 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.100.14.09-2
- kernel 2.6.21-5
* Thu Jun 14 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.100.14.09-1
- Version update
* Mon Jun 11 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.100.14.06-1
- Version update
- kernel 2.6.21-4
* Thu May 10 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.9755-4
- kernel 2.6.21-2
* Fri Apr 27 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.9755-3
- kernel 2.6.21-1
* Sun Apr 08 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.9755-2
- kernel 2.6.20-7
* Thu Mar 15 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.9755-1
- Version update
- Kernel 2.6.20-5
* Sat Feb 24 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.9746-5
- Kernel 2.6.20-4
* Thu Feb 22 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.9746-4
- Kernel 2.6.20-3
* Sat Feb 17 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.9746-3
- Kernel 2.6.20-2
* Tue Feb 06 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.9746-2
- Kernel 2.6.20-1
* Thu Jan 11 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.9746-1
- Version update
- Kernel 2.6.19-6
* Mon Jan 08 2007 Christian Metzen <metzench@ccux-linux.de> 1.0.9631-3
- Kernel 2.6.19-5
* Wed Dec 20 2006 Karsten Brockmann <arcam@ccux-linux.de> 1.0.9631-2
- Kernel 2.6.19-4
* Sun Dec 10 2006 Stefan Gottwald <gotti@ccux-linux.de> 1.0.9631-1
- Version update
* Thu Oct 26 2006 Karsten Brockmann <arcam@ccux-linux.de> 1.0.9625-5
- Kernel 2.6.18-4
* Thu Oct 26 2006 Karsten Brockmann <arcam@ccux-linux.de> 1.0.9625-4
- Kernel 2.6.18-3
* Mon Oct 23 2006 Karsten Brockmann <arcam@ccux-linux.de> 1.0.9625-3
- Kernel 2.6.18-2
* Sun Oct 01 2006 Karsten Brockmann <arcam@ccux-linux.de> 1.0.9625-2
- Version update
* Tue Sep 26 2006 Karsten Brockmann <arcam@ccux-linux.de> 1.0.9625-1
- Version update
* Thu Sep 14 2006 Christian Metzen <metzench@ccux-linux.de> 1.0.8774-1
- Version update
* Tue Aug 29 2006 Karsten Brockmann <arcam@ccux-linux.de> 1.0.8762-3
- Kernel 2.6.17-3
* Wed Aug 09 2006 Karsten Brockmann <arcam@ccux-linux.de> 1.0.8762-2
- Kernel 2.6.17-2
* Mon Jul 10 2006 Karsten Brockmann <arcam@ccux-linux.de> 1.0.8762-1
- version update, Kernel 2.6.17-1
* Fri Jul 07 2006 Karsten Brockmann <arcam@ccux-linux.de> 1.0.8756-4
- Kernel 2.6.17-1
* Sat May 13 2006 Christian Metzen <metzench@ccux-linux.de> 1.0.8756-3
- Kernel 2.6.16-5
* Wed May 10 2006 Christian Metzen <metzench@ccux-linux.de> 1.0.8756-2
- Kernel 2.6.16-4
* Tue Apr 18 2006 Christian Metzen <metzench@ccux-linux.de> 1.0.8756-1
- Initial Release with new kmod helper
